# -*- coding: utf-8 -*-

from openerp import models, fields, api

class RepairWorkorder(models.Model):
	_inherit = 'repair.workorder'

	@api.model
	def getRepairWorkorder(self,domain):
		RepairWorkorder = self.env['repair.workorder'].search(domain)
		values = []
		for workorder in RepairWorkorder:
			try:
				street = workorder.partner_id.street
			except Exception as e:
				street = ''
			values.append({
                # ID
				'id': workorder.id,
                # WORKORDER INFO
                'name': workorder.name,
                'user_name': workorder.user_id.name,
                'causes': workorder.causes,
                'order_date': workorder.order_date,
                'planned_start_date': workorder.planned_start_date,
                'planned_end_date': workorder.planned_end_date,
				'diagnostic': workorder.diagnostic,
                'recommendations': workorder.recommendations,
                'actions': workorder.actions,
                # PARTNER INFO
				'partner_id': workorder.partner_id.id,
				'partner_name': workorder.partner_id.name,
				'partner_address': street,
                'partner_phone': workorder.partner_id.phone,
				'partner_mobile': workorder.partner_id.mobile,
                # COMPANY INFO
                'company_id': workorder.user_id.company_id.id,
                'company_name': workorder.user_id.company_id.name,
                'company_logo': workorder.user_id.company_id.logo,
				'imageheader': workorder.user_id.company_id.imageheader,
                'company_address': workorder.user_id.company_id.street2,
                'company_phone': workorder.user_id.company_id.phone,
			})

		return values

class RepairWorkorderLine(models.Model):
	_inherit = 'repair.workorder.line'

	@api.model
	def getRepairWorkorderLine(self,domain):
		RepairWorkorderLine = self.env['repair.workorder.line'].search(domain)
		values = []
		for line in RepairWorkorderLine:
			values.append({
                # ID
				'id': line.id,
                # LINE INFO
                'workorder_id': line.workorder_id.id,
                'description': line.description,
                'quantity': line.quantity,
                'brand': line.brand,
                'number': line.number,
			})

		return values

class RepairWorkorderConsumed(models.Model):
	_inherit = 'repair.workorder.consumed'

	@api.model
	def getRepairWorkorderConsumed(self,domain):
		RepairWorkorderConsumed = self.env['repair.workorder.consumed'].search(domain)
		values = []
		for line in RepairWorkorderConsumed:
			values.append({
                # ID
				'id': line.id,
                # LINE INFO
                'workorder_id': line.workorder_id.id,
                'product_id':[
                    line.product_id.id,
                    line.product_id.name,
                ],
                'description': line.description,
                'quantity': line.quantity,
                'price_unit': line.price_unit,
                'subtotal': line.subtotal,
			})

		return values
